#property copyright "ATP"

#include <stdlib.mqh>

extern int TP=600; // The Exact Amount Of the Pips u will get as the profit in your account
extern int SL=10; // Stop Loss amount in pips
extern int SecBPO=20; // Seconds Before News Which EA Will Place Pending Orders
extern int SecBMO=100; // Seconds Before News Which EA Will Stop Modifying Orders
extern int STWAN=300; // Seconds To Wait After News to Delete Pending Orders
extern bool OCO=true; // One Cancel The Other , will cancel the other pending order if one of them is hit
extern int BEPips=0; // Pips In profit which EA will Move SL to BE+1 after that
extern int TrailingStop=100; // Trailing Stop
extern double Lots=0.1;
extern string TradeLog = " MI_Log";
extern datetime Place_Order_Time=D'13:00:00';
extern double Buy_Price,Sell_Price,Buy_Stoploss,Sell_Stoploss,Buy_Takeprofit,Sell_Takeprofit; 
int Magic;
string filename;




//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
    ObjectsDeleteAll();
    return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
    Comment("");
    ObjectsDeleteAll();
    return(0);
}

int CheckOrdersCondition()
{
    int result=0;
    for (int i=0;i<OrdersTotal();i++) 
	 {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if ((OrderType()==OP_BUY) && (OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic)) 
	   {
        result=result+1000; 
      }
      if ((OrderType()==OP_SELL) && (OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic)) 
	   {
        result=result+100; 
      }
      if ((OrderType()==OP_BUYSTOP) && (OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic)) 
	  {
        result=result+10;
      }
      if ((OrderType()==OP_SELLSTOP) && (OrderSymbol() == Symbol()) && (OrderMagicNumber() == Magic)) 
	   {
        result=result+1; 
      }

    }
    return(result); // 0 means we have no trades
}
 
// OrdersCondition Result Pattern
//    1    1    1    1
//    b    s    bs   ss
//  
  
  
void OpenBuyStop()
{
    int ticket,err,tries;
        tries = 0;
        if (!GlobalVariableCheck("InTrade")) 
        {  
		    while (tries < 3)
            {
               GlobalVariableSet("InTrade", CurTime());  // set lock indicator
               ticket = OrderSend(Symbol(),OP_BUYSTOP,Lots,Buy_Price,1,Buy_Stoploss,Buy_Takeprofit,"A Trade",Magic,0,Red);
               Write("in function OpenBuyStop OrderSend Executed , ticket ="+ticket);
               GlobalVariableDel("InTrade");   // clear lock indicator
               if(ticket<=0) 
               {  
				      Write("Error Occured : "+ErrorDescription(GetLastError())+" BuyStop @ "+Buy_Price+" SL @ "+Buy_Stoploss+" TP @"+Buy_Takeprofit);
                  tries++;
               } 
			      else tries = 3;
            }
        }
}
  
void OpenSellStop()
{
    int ticket,err,tries;
        tries = 0;
        if (!GlobalVariableCheck("InTrade")) 
		  {
          while (tries < 3)
            {
               GlobalVariableSet("InTrade", CurTime());  // set lock indicator
               ticket = OrderSend(Symbol(),OP_SELLSTOP,Lots,Sell_Price,1,Sell_Stoploss,Sell_Takeprofit,"Asa Trade",Magic,0,Red);
               Write("in function OpenSellStop OrderSend Executed , ticket ="+ticket);
               GlobalVariableDel("InTrade");   // clear lock indicator
               if(ticket<=0) 
			      {
                  Write("Error Occured : "+ErrorDescription(GetLastError())+" BuyStop @ "+Sell_Price+" SL @ "+Sell_Stoploss+" TP @"+Sell_Takeprofit);
                  tries++;
               } 
			      else tries = 3;
            }
        }
}
 
void DoBE(int byPips) 
{
    for (int i = 0; i < OrdersTotal(); i++) 
	{
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     if ( OrderSymbol()==Symbol() && (OrderMagicNumber() == Magic))  // only look if mygrid and symbol...
         {
            if (OrderType() == OP_BUY) if (Bid - OrderOpenPrice() > byPips * Point) if (OrderStopLoss() < OrderOpenPrice()) 
			   {
              Write("Moving StopLoss of Buy Order to BE+1");
              OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() +  Point, OrderTakeProfit(), Red);
            }
            if (OrderType() == OP_SELL) if (OrderOpenPrice() - Ask > byPips * Point) if (OrderStopLoss() > OrderOpenPrice()) 
			   { 
               Write("Moving StopLoss of Buy Order to BE+1");
               OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() -  Point, OrderTakeProfit(), Red);
            }
        }
    }
}

void DoTrail() 
{
   for (int i = 0; i < OrdersTotal(); i++) 
	{
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if ( OrderSymbol()==Symbol() && (OrderMagicNumber() == Magic))  // only look if mygrid and symbol...
      {          
          if (OrderType() == OP_BUY) 
		    {
             if(Bid-OrderOpenPrice()>Point*TrailingStop)
             {
                if(OrderStopLoss()<Bid-Point*TrailingStop)
                  {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                  }
             }
          }

          if (OrderType() == OP_SELL) 
          {
             if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
             {
                if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                {
                   OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                   return(0);
                }
             }
          }
       }
    }
}
 

void DeleteBuyStop() 
{
   for (int i = 0; i < OrdersTotal(); i++) 
   {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol()==Symbol() && (OrderMagicNumber() == Magic) && (OrderType()==OP_BUYSTOP)) 
	    {
          OrderDelete(OrderTicket());
          Write("in function DeleteBuyStopOrderDelete Executed");
       }       
    }
}
   
void DeleteSellStop() 
{
   for (int i = 0; i < OrdersTotal(); i++) 
   {
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if (OrderSymbol()==Symbol() && (OrderMagicNumber() == Magic) && (OrderType()==OP_SELLSTOP)) 
	    {
          OrderDelete(OrderTicket());
          Write("in function DeleteSellStopOrderDelete Executed");
       }       
    }
}

void DoModify() 
{
   for (int i = 0; i < OrdersTotal(); i++) 
   {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && (OrderMagicNumber() == Magic) && (OrderType()==OP_SELLSTOP)) 
	   {
         if ((OrderOpenPrice()>Sell_Price) || (OrderOpenPrice()<Sell_Price)) 
	      {
            Write("in function DoModify , SellStop OrderModify Executed, Sell Stop was @ "+DoubleToStr(OrderOpenPrice(),4)+" it changed to "+DoubleToStr(Sell_Price,4));
            OrderModify(OrderTicket(), Sell_Price,Sell_Stoploss,Sell_Takeprofit,0,Red);
         }
      }

      if (OrderSymbol()==Symbol() && (OrderMagicNumber() == Magic) && (OrderType()==OP_BUYSTOP)) 
	   {
         if ((OrderOpenPrice()>Buy_Price) || (OrderOpenPrice()<Buy_Price)) 
	      {
            Write("in function DoModify , BuyStop OrderModify Executed, Buy Stop was @ "+DoubleToStr(OrderOpenPrice(),4)+" it changed to "+DoubleToStr(Buy_Price,4));
            OrderModify(OrderTicket(), Buy_Price,Buy_Stoploss,Buy_Takeprofit,0,Red);
         }
      }
   }
}

int Write(string str)
{
   int handle;
  
   handle = FileOpen(filename,FILE_READ|FILE_WRITE|FILE_CSV,"/t");
   FileSeek(handle, 0, SEEK_END);      
   FileWrite(handle,str + " Time " + TimeToStr(CurTime(),TIME_DATE|TIME_SECONDS));
   FileClose(handle);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()
{  
   Magic= TimeDay(TimeLocal()) + TimeHour(TimeLocal()) + TimeMinute(TimeLocal());   
         
   int OrdersCondition,secofday;
      
   filename=Symbol() + TradeLog + "-" + Month() + "-" + Day() + ".txt";

   if (BEPips>0) DoBE(BEPips);
   
   if (TrailingStop>0) DoTrail();
  
   OrdersCondition=CheckOrdersCondition();
   
   secofday=Hour()*3600+Minute()*60+Seconds();
   
   Buy_Price=Bid;
   Sell_Price=Ask;
   Buy_Stoploss=Bid-SL*Point; 
   Sell_Stoploss=Ask+SL*Point; 
   Buy_Takeprofit=Bid+TP*Point;
   Sell_Takeprofit=Ask-TP*Point;
   
   Comment("\nSemi Auto Trader Expert Advisor v1\n\nBuy Order @ ",Buy_Price," Stoploss @ ",Buy_Stoploss," TakeProfit @ ",Buy_Takeprofit,"\nSell Order @ ",Sell_Price," StopLoss @ ",Sell_Stoploss," TakeProfit @ ",Sell_Takeprofit,"  SecBPO : ",SecBPO," SecBMO : ",SecBMO," STWAN : ",STWAN," OCO : ",OCO," BEPips : ",BEPips," Lots : "Lots"";
   
   if (TimeLocal()==(Place_Order_Time-SecBPO)) 
   {      
      if (OrdersCondition==0) 
	   {
         Write("Opening BuyStop & SellStop, OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
         OpenBuyStop();
         OpenSellStop();
      }

      if (OrdersCondition==10) 
	   {
         Write("Opening SellStop, OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
         OpenSellStop();
      }
      
      if (OrdersCondition==1) 
	   {
         Write("Opening BuyStop , OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
         OpenBuyStop();
      }
   }
 
   if (TimeLocal()==(Place_Order_Time-SecBMO)) 
   {
         Write("Modifying Orders, OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
         DoModify();
   }     


   if (OCO==true) 
   {
      if (OrdersCondition==1001) 
	   {
         Write("Deleting SellStop Because of BuyStop Hit, OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
         DeleteSellStop();
      }
      
      if (OrdersCondition==110) 
	   {
         Write("Deleting BuyStop Because of SellStop Hit, OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
         DeleteBuyStop();
      }
   }
   
   if (TimeLocal()==(Place_Order_Time+STWAN)) 
   {
      if (OrdersCondition==11) 
	   {
         Write("Deleting BuyStop and SellStop Because time expired, OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
         DeleteBuyStop();
         DeleteSellStop();
      }
      
      if ((OrdersCondition==10) || (OrdersCondition==110)) 
	   {
         Write("Deleting BuyStop Because expired, OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
         DeleteBuyStop();
      }
      
      if ((OrdersCondition==1) || (OrdersCondition==1001)) 
	   {
         Write("Deleting SellStop Because expired, OrdersCondition="+OrdersCondition+" SecOfDay="+secofday);
         DeleteSellStop();
      }
   }
   
   return(0);
}

  
  

//+------------------------------------------------------------------+

